formBuilder
===========
| Branch | Build Status |
|:-------|:-------------|
| v2.1.9 | [![Build Status](https://travis-ci.org/autodatadirect/formBuilder.svg?branch=v2.1.9)](https://travis-ci.org/autodatadirect/formBuilder/branches) |
| master | [![Build Status](https://travis-ci.org/autodatadirect/formBuilder.svg?branch=master)](https://travis-ci.org/autodatadirect/formBuilder/branches) |
| dev | [![Build Status](https://travis-ci.org/autodatadirect/formBuilder.svg?branch=dev)](https://travis-ci.org/autodatadirect/formBuilder/branches) |

# Documentation
Checkout the GitHub page docs [here](http://autodatadirect.github.io/formBuilder/)!

# About

## What is formBuilder?
FormBuilder is a library that can be used to create forms online. These forms will be able to accept user input and save the data in varying ways depending on what data-types have been chosen for the input fields.

There are many different input field data-types and each have different filters, validation methods, and options that dictate what kind of data they can or can not accept, and how the input fields will look and behave. These types have been developed to meet the typical needs of what would be desired from an online form, such as a phone number type, an email type, a regular text input type, and many more. If you would like to see a full list of the input types that are available to you with formBuilder please feel free to look ahead to the <a href="./guide.html#dataTypes">Data Types</a> section in the User Guide.

It is also possible, if these types do not meet the requirements of what is needed for a form that is being built, to easily design a custom input type by modifying a set of base methods, or developing a regular expression to define what input will be allowed in the new type. A more detailed description of how to do this can be found in the <a href="./guide.html#customization">Customization</a> section of the User Guide.

If you would like to see an example of a form that is built using formBuilder, and how the data from that form is saved, feel free to look ahead to our <a href="./guide.html#demo">Live Demo</a>.

## How is formBuilder used?
FormBuilder is used by creating forms and then initializing them as formBuilder widgets. FormBuilder will construct the form fields automatically. You can then build upon those forms by adding as many different kinds of input as are desired.

If you would like to know how to use formBuilder and see examples of each different input types and how they work, please feel free to look ahead to the <a href="./guide.html#basics">User Guide</a>.

For a more in-depth understanding of how to use and manipulate each different available resource in the formBuilder library, please feel free to look ahead to our <a href='./api.html#widgets'>[API Reference]()</a>

## Why should I use formBuilder?
FormBuilder allows you to create complicated input fields on forms by using only one or two lines of code in your html file. By implementing one or two attributes on an input field you will be able to apply large changes to how the field will appear and how it will handle data.

It is also a quick and easy way to be able to eliminate most human error from any online form that you are trying to build. By using input types that have been designed to only accept certain entries you can help to prevent the chance that forms will be submitted to you incorrectly.

FormBuilder is also very easy to understand and implement into your code. The user guide and API reference that have been provided to you are useful tools to be able to understand and see examples of how to build your form using formBuilder. In short, formBuilder is a useful tool that can be used to enhance any online form that you are trying to build.



## Credits
Auto Data Direct, Inc.

## License
MIT
